        LIST p=16F84A
	#include "P16F84A.INC"
	#include "MidiKbd.INC"
        goto    MAIN_INIT

MAIN_INIT	;  
        bsf     STATUS,RP0
        movlw   0x10
        movwf   TRISA
        movlw   0x7F
        movwf   TRISB
        bcf     OPTION_REG,NOT_RBPU
        bcf     STATUS,RP0
;  
        movlw   0x43
        movwf   tmp0
        movlw   0x4F
        movwf   FSR
INIT_RESET
        clrf    INDF
        decf    FSR,F
        decfsz  tmp0,F
        goto    INIT_RESET
;     
        clrf    PORTA
        bsf     PORTB,0x7
        comf    wrkNumCtrl,F
        movlw   D'63'
        movwf   wrkVolume
        movlw   0x5
        movwf   tmpCntVolChng

MAIN_START	;  
        call    READ_VOLUME
        call    READ_CONFIG_BTN
        movlw   B'11111000'
        andwf   PORTA,F
        movlw   0x20
        movwf   FSR
;  
        btfsc   wrkSTATUS,0x2
        bcf     PORTA,0x3
        btfss   wrkSTATUS,0x2
        bsf     PORTA,0x3

CHECK_EVENTS	;  
        call    READ_PORTB
        movf    INDF,W
        xorwf   wrkSTATUS,W
        andlw   B'00000001'
        btfss   STATUS,Z
        call    SEND_BTN_MIDIDATA
;   
        movlw   B'00000001'
        andwf   wrkSTATUS,W
        movwf   INDF

; 
        incf    FSR,F
        movf    PORTA,W
        andlw   B'00000111'
        xorlw   D'7'
        btfsc   STATUS,Z
        goto    CHECK_OVERCOUNT
        incf    PORTA,F
        goto    CHECK_EVENTS

CHECK_OVERCOUNT ;  
        movlw   B'11111000'
        andwf   PORTA,F

        movf    FSR,W
        xorlw   0x50
        btfss   STATUS,Z
        goto    CHECK_EVENTS
        goto    MAIN_START

SEND_BTN_MIDIDATA ;   "/ "
        btfsc   wrkSTATUS,0x2
        return
        movlw   0x90
        addwf   wrkChanl,W
        call    SEND_MIDI_DATA
        movlw   0x20
        subwf   FSR,W
        addlw   _KbdStart
        call    SEND_MIDI_DATA
        movlw   0x0
        btfss   INDF,0x0
        movf    wrkVolume,W
        call    SEND_MIDI_DATA
        return

SEND_MIDI_DATA  ;   MIDI  ( W)
        movwf   tmp1
        clrf    tmp0
        bsf     tmp0,0x1
        call    SEND_DATA_BIT

        movf    tmp1,W
        movwf   tmp0
        bcf     STATUS,C
        rlf     tmp0,F
        rlf     tmp0,F
        call    SEND_DATA_BIT


        call    SEND_DATA_BIT
        call    SEND_DATA_BIT
        call    SEND_DATA_BIT
        call    SEND_DATA_BIT
        call    SEND_DATA_BIT
        call    SEND_DATA_BIT
        call    SEND_DATA_BIT
        call    SEND_DATA_BIT

;    MIDI
        nop
        movlw   0x9
        movwf   wrkDel
SEND_MIDI_DATA_DEL
        decfsz  wrkDel,F
        goto    SEND_MIDI_DATA_DEL
        bsf     PORTB,0x7

        return

READ_PORTB      ;    B
        bcf     STATUS,C
        rrf     FSR,W
        movwf   tmp1
        bcf     STATUS,C
        rrf     tmp1,F
        bcf     STATUS,C
        rrf     tmp1,F
        movlw   0x4
        subwf   tmp1,W
        call    _READ_PORTB_TABLE210
        andwf   PORTB,W
;     - wrkSTATUS:0
        btfss   STATUS,Z
        bcf     wrkSTATUS,0x0
        btfsc   STATUS,Z
        bsf     wrkSTATUS,0x0
        return
_READ_PORTB_TABLE210
        addwf   PCL,F
        retlw   B'00000001'
        retlw   B'00000010'
        retlw   B'00000100'
        retlw   B'00001000'
        retlw   B'00010000'
        retlw   B'00100000'
        retlw   B'01000000'
        retlw   B'10000000'

READ_VOLUME	;  
        btfsc   wrkSTATUS,0x2
        return

        btfsc   PORTB,0x6
        incf    tmpVolume,F
;    
        btfsc   PORTB,0x6
        return
;  
        bcf     PORTA,0x3
        bsf     PORTA,0x3
;   
        bcf     STATUS,C
        rlf     tmpVolume,F
        rlf     tmpVolume,W
        clrf    tmpVolume

        btfss   wrkNumCtrl,0x7
        goto    _READ_VOLUME_SEND_CTRL
        movwf   wrkVolume
        return
_READ_VOLUME_SEND_CTRL;   
        movwf   wrkCtrl
        xorwf   tmpCtrl,W
        btfsc   STATUS,Z
        return
        decfsz  tmpCntVolChng,F
        return
;   
        movlw   0xB0
        addwf   wrkChanl,W
        call    SEND_MIDI_DATA
        movf    wrkNumCtrl,W
        call    SEND_MIDI_DATA
        movf    wrkCtrl,W
        call    SEND_MIDI_DATA

        movf    wrkCtrl,W
        movwf   tmpCtrl
        movlw   0x5
        movwf   tmpCntVolChng
        
        return

READ_CONFIG_BTN ;   
        btfss   PORTA,0x4
        btfsc   wrkSTATUS,0x3
        goto    _READ_CONFIG_BTN_WRITE_STATE
        comf    wrkSTATUS,W
        movwf   tmp0
        btfss   tmp0,0x2
        bcf     wrkSTATUS,0x2
        btfsc   tmp0,0x2
        bsf     wrkSTATUS,0x2

_READ_CONFIG_BTN_WRITE_STATE ;   
        btfss   PORTA,0x4
        bsf     wrkSTATUS,0x3
        btfsc   PORTA,0x4
        bcf     wrkSTATUS,0x3
; wrkSTATUS:2 -   
        btfss   wrkSTATUS,0x2
        return

;  
        movlw   0x2F
        movwf   FSR
        movlw   0x10
        movwf   tmp0
_READ_CONFIG_BTN_CHECK_CHNL ;    
        btfsc   INDF,0x0
        goto    _READ_CONFIG_BTN_WRITE_CHNL
        decf    FSR,F
        decfsz  tmp0,F
        goto    _READ_CONFIG_BTN_CHECK_CHNL
        goto    _READ_CONFIG_BTN_READ_CTRL
_READ_CONFIG_BTN_WRITE_CHNL ;   
        decf    tmp0,W
        movwf   wrkChanl

_READ_CONFIG_BTN_READ_CTRL ;   
        movlw   0x4F
        movwf   FSR
        movlw   0x20
        movwf   tmp0
_READ_CONFIG_BTN_CHECK_CTRL ;    
        btfsc   INDF,0x0
        goto    _READ_CONFIG_BTN_WRITE_CTRL
        decf    FSR,F
        decfsz  tmp0,F
        goto    _READ_CONFIG_BTN_CHECK_CTRL
        return
_READ_CONFIG_BTN_WRITE_CTRL ;   
        movlw   0x3
        subwf   tmp0,W
        movwf   wrkNumCtrl
        return

SEND_DATA_BIT 	;    tmp0:0  PORTB:7
        nop
;  32 
        movlw   0x7
        movwf   wrkDel
_SEND_DATA_BIT_DEL0 ;   MIDI
        decfsz  wrkDel,F
        goto    _SEND_DATA_BIT_DEL0
        rrf     tmp0,F
        btfss   tmp0,0x0
        goto    _SEND_DATA_BIT_SET0
        nop
;  1
        bsf     PORTB,0x7
        return
_SEND_DATA_BIT_SET0 ;  0
        bcf     PORTB,0x7
        return

; 
        movlw   0x10
        movwf   tmp1
_SEND_DATA_BIT_DEL ; 
        decfsz  tmp1,F
        goto    _SEND_DATA_BIT_DEL
        return
        END
